<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 09/09/2008 *
 * ===================                          Last change: 09/09/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : load_cache-modules.php                           *
 * -------------------------------------------------------------------- *
 * Short description : Load more cache files                            *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Mehr Cache-Dateien nachladen                     *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009, 2010 by Mailer Developer Team                    *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} // END - if

// Use this code if you don't want to run this cache loader on installation phase
if (isInstallationPhase()) return;

// Next cached table is the module registry (mod_reg)...
if (($GLOBALS['cache_instance']->loadCacheFile('modules')) && ($GLOBALS['cache_instance']->extensionVersionMatches('sql_patches'))) {
	// Load cache
	$GLOBALS['cache_array']['modules'] = $GLOBALS['cache_instance']->getArrayFromCache();

	// Rewrite module cache
	$modArray = $GLOBALS['cache_array']['modules'];

	// Do only process valid arrays
	if (!isset($modArray['module'])) {
		// We should fix this!
		debug_report_bug('modArray=<pre>'.print_r($modArray, true).'</pre>');
	} // END - if

	// Rewrite some parts
	foreach ($modArray['module'] as $key => $mod) {
		// Add all
		foreach (array('id','title','locked','hidden','admin_only','mem_only','has_menu') as $entry) {
			// Is the entry set?
			if (isset($GLOBALS['cache_array']['modules'][$entry][$key])) {
				// Transfer it
				$GLOBALS['cache_array']['modules'][$entry][$mod] = $modArray[$entry][$key];

				// And delete cache
				unset($GLOBALS['cache_array']['modules'][$entry][$key]);
			} else {
				// Log this for debug purposes
				logDebugMessage(basename(__FILE__), __LINE__, 'Entry not found. module=' . $mod . ',key=' . $key . ',entry=' . $entry);
			}
		} // END - foreach
	} // END - foreach
	unset($modArray);
} elseif (getOutputMode() != 1) {
	// Create cache file here
	$GLOBALS['cache_instance']->init();

	// Load all modules and their data
	if (isExtensionInstalledAndNewer('sql_patches', '0.3.6')) {
		// Load has_menu
		$result = SQL_QUERY('SELECT
	`id`, `module`, `title`, `locked`, `hidden`, `admin_only`, `title`, `mem_only`, `has_menu`
FROM
	`{?_MYSQL_PREFIX?}_mod_reg`
ORDER BY
	`module` ASC', __FILE__, __LINE__);
	} else {
		// Don't load has_menu
		$result = SQL_QUERY('SELECT
	`id`, `module`, `title`, `locked`, `hidden`, `admin_only`, `title`, `mem_only`
FROM
	`{?_MYSQL_PREFIX?}_mod_reg`
ORDER BY
	`module` ASC', __FILE__, __LINE__);
	}

	// Cache all data
	while ($content = SQL_FETCHARRAY($result)) {
		// Add row to cache file
		$GLOBALS['cache_instance']->addRow($content);
	} // END - while

	// Free memory
	SQL_FREERESULT($result);

	// Close the cache
	$GLOBALS['cache_instance']->storeExtensionVersion('sql_patches');
	$GLOBALS['cache_instance']->finalize();
}

// [EOF]
?>
