<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 04/11/2004 *
 * ===================                          Last change: 08/12/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-config_payouts.php                          *
 * -------------------------------------------------------------------- *
 * Short description : Configure payout types                           *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Auszahlungensarten editieren                     *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009, 2010 by Mailer Developer Team                    *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
}

// Add description as navigation point
addMenuDescription('admin', __FILE__);

if (isPostRequestParameterSet('rate')) setPostRequestParameter('rate', convertCommaToDot(postRequestParameter('rate')));

if ((isFormSent('add')) && (isPostRequestParameterSet('title')) && (postRequestParameter('rate') > 0)) {
	// Add new payout type
	$result = SQL_QUERY_ESC("SELECT `id` FROM `{?_MYSQL_PREFIX?}_payout_types` WHERE type='%s' LIMIT 1",
	array(postRequestParameter('title')), __FILE__, __LINE__);
	if (SQL_HASZERONUMS($result)) {
		// Add now
		SQL_QUERY_ESC("INSERT INTO `{?_MYSQL_PREFIX?}_payout_types`
(type, rate, min_points, from_account, from_pass, engine_url, engine_ret_ok, engine_ret_failed, pass_enc, allow_url)
VALUES ('%s', %d, %d,'%s','%s','%s','%s','%s','%s','%s')",
		array(
			postRequestParameter('title'),
			bigintval(postRequestParameter('rate')),
			bigintval(postRequestParameter('min_points')),
			postRequestParameter('yacc'),
			postRequestParameter('ypass'),
			postRequestParameter('yurl'),
			postRequestParameter('yrdone'),
			postRequestParameter('yrfailed'),
			postRequestParameter('ytrans'),
			postRequestParameter('allow_url'),
		), __FILE__, __LINE__);

		// Get message
		$message = getMessage('ADMIN_PAYOUT_TYPE_ADDED');
	} else {
		// Free memory
		SQL_FREERESULT($result);

		// Does already exist
		$message = '<div class="admin_failed">{--ADMIN_PAYOUT_TYPE_ALREADY--}</div>';
	}
}

// Payout requests by your members
$result_mem = SQL_QUERY("SELECT `id` FROM `{?_MYSQL_PREFIX?}_user_payouts` WHERE `status`='NEW' ORDER BY payout_timestamp DESC", __FILE__, __LINE__);

$display = true;
if ((isFormSent('edit')) && (countPostSelection() > 0)) {
	// Edit payout types
	if ((isGetRequestParameterSet('ok')) && (getRequestParameter('ok') == 'ok')) {
		// Init SQLs
		initSqls();

		// Edit entries
		foreach (postRequestParameter('sel') as $id => $sel) {
			// Secure id
			$id = bigintval($id);

			// Edit only if something is entered
			if ((isPostRequestParameterSet('title', $id)) && (postRequestParameter('rate', $id) > 0)) {
				// Update entry
				addSql(SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_payout_types` SET
type='%s',
rate=%s,
min_points=%s,
allow_url='%s'
WHERE `id`='".$id."' LIMIT 1",
				array(
					postRequestParameter('title', $id),
					convertCommaToDot(postRequestParameter('rate', $id)),
					convertCommaToDot(postRequestParameter('min_points' , $id)),
					postRequestParameter('allow', $id),
				),__FILE__, __LINE__, false));
			}
		}

		// Run all SQLs
		runFilterChain('run_sqls');

		// Get message
		$message = getMessage('ADMIN_PAYOUT_ENTRIES_CHANGED');
	} else {
		$display = false; //Suppress any other outputs
		$OUT = ''; $SW = 2;
		foreach (postRequestParameter('sel') as $id => $sel) {
			// Load data
			$result = SQL_QUERY_ESC("SELECT type, rate, min_points, allow_url FROM `{?_MYSQL_PREFIX?}_payout_types` WHERE `id`=%s LIMIT 1",
			array(bigintval($id)), __FILE__, __LINE__);
			list($title, $rate, $min_points, $allow) = SQL_FETCHROW($result);
			SQL_FREERESULT($result);

			// Prepare data for the row template
			$content = array(
				'sw'    => $SW,
				'id'    => $id,
				'title' => $title,
				'rate'  => translateComma($rate),
				'min_points'  => translateComma($min_points),
				'allow' => addSelectionBox('yn', $allow, "allow[".$id."]"),
			);

			// Load row template and switch color
			$OUT .= loadTemplate('admin_config_payouts_edit_row', true, $content);
			$SW = 3 - $SW;
		}

		// Load main template
		loadTemplate('admin_config_payouts_edit', false, $OUT);
	}
} elseif ((isFormSent('del')) && (countPostSelection() > 0)) {
	// Delete payout types
	if ((isGetRequestParameterSet('ok')) && (getRequestParameter('ok') == 'ok')) {
		// Init SQLs
		initSqls();

		// Delete entries
		foreach (postRequestParameter('sel') as $id => $sel) {
			addSql(SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_payout_types` WHERE `id`=%s LIMIT 1",
			array(bigintval($id)), __FILE__, __LINE__, false));
		} // END - foreach

		// Run all SQLs
		runFilterChain('run_sqls');

		// Get message
		$message = getMessage('ADMIN_PAYOUT_ENTRIES_DELETED');
	} else {
		$display = false; //Suppress any other outputs
		$OUT = ''; $SW = 2;
		foreach (postRequestParameter('sel') as $id => $sel) {
			// Secure id number
			$id = bigintval($id);

			// Load data
			$result = SQL_QUERY_ESC("SELECT type, rate, min_points FROM `{?_MYSQL_PREFIX?}_payout_types` WHERE `id`=%s LIMIT 1",
			array($id), __FILE__, __LINE__);
			list($title, $rate, $min_points) = SQL_FETCHROW($result);
			SQL_FREERESULT($result);

			// Prepare data for the row template
			$content = array(
				'sw'    => $SW,
				'id'    => $id,
				'title' => $title,
				'rate'  => translateComma($rate),
				'min_points'  => translateComma($min_points),
			);

			// Load row template and switch color
			$OUT .= loadTemplate('admin_config_payouts_del_row', true, $content);
			$SW = 3 - $SW;
		}

		// Load main template
		loadTemplate('admin_config_payouts_del', false, $OUT);
	}
}

if (!empty($message)) {
	// Output message
	loadTemplate('admin_settings_saved', false, $message);
} // END - if

// Payout types
$result_type = SQL_QUERY("SELECT
	`id`, `type`, `rate`, `min_points`, `from_account`
FROM
	`{?_MYSQL_PREFIX?}_payout_types`
ORDER BY
	`type` ASC", __FILE__, __LINE__);

if ((SQL_NUMROWS($result_type) > 0) && ($display)) {
	// List all payout types
	$OUT = ''; $SW = 2;
	while ($content = SQL_FETCHARRAY($result_type)) {
		// Prepare data for the row template
		$content = array(
			'sw'           => $SW,
			'id'           => $content['id'],
			'from_account' => $content['from_account'],
			'type'         => $content['type'],
			'rate'         => translateComma($content['rate']),
			'min_points'   => translateComma($content['min_points']),
		);

		// Load row template and switch color
		$OUT .= loadTemplate('admin_config_payouts_row', true, $content);
		$SW = 3 - $SW;
	} // END - while

	// Free memory
	SQL_FREERESULT($result_type);

	// Load main template
	loadTemplate('admin_config_payouts', false, $OUT);
}

// Does your members request payouts?
if ((SQL_NUMROWS($result_mem) > 0) && ($display)) {
	// Members has requested payouts
	loadTemplate('admin_settings_saved', false, '<a href="{%url=modules.php?module=admin&amp;what=list_payouts%}">{--ADMIN_PAYOUT_LIST_REQUESTS--}</a>');
} elseif ($display) {
	// No member requests so far
	loadTemplate('admin_settings_saved', false, getMessage('ADMIN_PAYOUT_NO_MEMBER_REQUESTS'));
}

// Free result
SQL_FREERESULT($result_mem);

// Add new payout type
if ($display === true) loadTemplate('admin_payout_add_new');

// [EOF]
?>
